/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.inputDevice;

/**
 * ゲームパッドで使用できるボタンを識別します.
 * <br>
 *
 * <br>
 *
 * @version 1.0.0 - 2013/01/14_13:17:13<br>
 * @author Dra0211<br>
 */
public enum GamePadButtons {

	/** この列挙はデジタルボタンを表します. */
	A(0),
	/** この列挙はデジタルボタンを表します. */
	B(1),
	/** この列挙はデジタルボタンを表します. */
	X(2),
	/** この列挙はデジタルボタンを表します. */
	Y(3),
	/** この列挙はデジタルボタンを表します. */
	LB(4),
	/** この列挙はデジタルボタンを表します. */
	RB(5),
	/** この列挙はデジタルボタンを表します. */
	LEFT_STICK(6),
	/** この列挙はデジタルボタンを表します. */
	RIGHT_STICK(7),
	/** この列挙はデジタルボタンを表します. */
	PAD_UP(8),
	/** この列挙はデジタルボタンを表します. */
	PAD_DOWN(9),
	/** この列挙はデジタルボタンを表します. */
	PAD_LEFT(10),
	/** この列挙はデジタルボタンを表します. */
	PAD_RIGHT(11),
	/** この列挙はデジタルボタンを表します. */
	START(12),
	/** この列挙はデジタルボタンを表します. */
	BACK(13);
	/** DLLから返される配列中の、このボタンの状態が格納されている場所のインデックスです. */
	private int value;

	/**
	 * インデックスの位置を取得します.
	 * @return インデックスを返します。<br>
	 */
	public int getValue() {
		return value;
	}

	private GamePadButtons(int value) {
		this.value = value;
	}

	/**
	 * kinugasa : GamePadButtons.Triggers : ゲームコントローラで使用できるアナログトリガーの列挙です.
	 * 
	 * @version 1.0.0 - 2012/06/22_21:10:56.<br>
	 * @author dra0211 ( <a href="mailto:d0211@live.jp">d0211@live.jp</a>&nbsp),).<br>
	 * <br>
	 *
	 */
	public enum Triggers {

		/** この列挙は0.0fから1.0fのアナログ値を取得できるボタンを表します. */
		LEFT(14),
		/** この列挙は0.0fから1.0fのアナログ値を取得できるボタンを表します. */
		RIGHT(15),;
		/** DLLから返される配列中の、このボタンの状態が格納されている場所のインデックスです. */
		private int value;

		/**
		 * インデックスの位置を取得します.
		 * @return インデックスを返します。<br>
		 */
		public int getValue() {
			return value;
		}

		private Triggers(int value) {
			this.value = value;
		}
	}

	/**
	 * kinugasa : GamePadButtons.ThumbSticks : ゲームコントローラで使用できるアナログスティックの列挙です.
	 * 
	 * @version 1.0.0 - 2012/06/22_21:10:56.<br>
	 * @author dra0211 ( <a href="mailto:d0211@live.jp">d0211@live.jp</a>&nbsp),).<br>
	 * <br>
	 *
	 */
	public enum ThumbSticks {

		/** この列挙は-1.0fから1.0fのアナログ値を取得できるボタンを表します. */
		LEFT_X(16),
		/** この列挙は-1.0fから1.0fのアナログ値を取得できるボタンを表します. */
		LEFT_Y(17),
		/** この列挙は-1.0fから1.0fのアナログ値を取得できるボタンを表します. */
		RIGHT_X(18),
		/** この列挙は-1.0fから1.0fのアナログ値を取得できるボタンを表します. */
		RIGHT_Y(19),;
		/** DLLから返される配列中の、このボタンの状態が格納されている場所のインデックスです. */
		private int value;

		/**
		 * インデックスの位置を取得します.
		 * @return インデックスを返します。<br>
		 */
		public int getValue() {
			return value;
		}

		private ThumbSticks(int value) {
			this.value = value;
		}
	}
}
